(function(global2, factory) {
  typeof exports === "object" && typeof module !== "undefined" ? factory(exports) : typeof define === "function" && define.amd ? define(["exports"], factory) : (global2 = typeof globalThis !== "undefined" ? globalThis : global2 || self, factory(global2.utils = {}));
})(this, function(exports2) {
  "use strict";var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);

  var ut = Object.defineProperty;
  var at = (n, t, e) => t in n ? ut(n, t, { enumerable: true, configurable: true, writable: true, value: e }) : n[t] = e;
  var c = (n, t, e) => at(n, typeof t != "symbol" ? t + "" : t, e);
  function lt(n, t = false) {
    if (n == null) throw new Error("Cannot clean a NULL value");
    return Array.isArray(n) ? n = n.filter((e) => e != null) : Object.entries(n).forEach(([e, r]) => {
      (t && r === void 0 || !t && r == null) && delete n[e];
    }), n;
  }
  function $(n, t) {
    const e = typeof n, r = typeof t;
    return e != "object" || n == null || r != "object" || t == null ? e == "function" && r == "function" ? n.toString() == t.toString() : n === t : Object.keys(n).length != Object.keys(t).length ? false : Object.keys(n).every((i) => $(n[i], t[i]));
  }
  function k(n) {
    try {
      return JSON.parse(n);
    } catch {
      return n;
    }
  }
  function It(n, t) {
    let e = [];
    return JSON.stringify(n, (r, s) => {
      if (typeof s == "object" && s !== null) {
        if (e.includes(s)) return;
        e.push(s);
      }
      return s;
    }, t);
  }
  function b(n) {
    return Array.isArray(n) ? n : [n];
  }
  class E extends Array {
    /** Number of elements in set */
    get size() {
      return this.length;
    }
    /**
     * Array to create set from, duplicate values will be removed
     * @param {T[]} elements Elements which will be added to set
     */
    constructor(t = []) {
      super(), t != null && t.forEach && t.forEach((e) => this.add(e));
    }
    /**
     * Add elements to set if unique
     * @param items
     */
    add(...t) {
      t.filter((e) => !this.has(e)).forEach((e) => this.push(e));
    }
    /**
     * Delete elements from set
     * @param items Elements that will be deleted
     */
    delete(...t) {
      t.forEach((e) => {
        const r = this.indexOf(e);
        r != -1 && this.slice(r, 1);
      });
    }
    /**
     * Create list of elements this set has which the comparison set does not
     * @param {ASet<T>} set Set to compare against
     * @return {ASet<T>} Different elements
     */
    difference(t) {
      return new E(this.filter((e) => !t.has(e)));
    }
    /**
     * Check if set includes element
     * @param {T} el Element to look for
     * @return {boolean} True if element was found, false otherwise
     */
    has(t) {
      return this.indexOf(t) != -1;
    }
    /**
     * Create list of elements this set has in common with the comparison set
     * @param {ASet<T>} set Set to compare against
     * @return {boolean} Set of common elements
     */
    intersection(t) {
      return new E(this.filter((e) => t.has(e)));
    }
    /**
     * Check if this set has no elements in common with the comparison set
     * @param {ASet<T>} set Set to compare against
     * @return {boolean} True if nothing in common, false otherwise
     */
    isDisjointFrom(t) {
      return this.intersection(t).size == 0;
    }
    /**
     * Check if all elements in this set are included in the comparison set
     * @param {ASet<T>} set Set to compare against
     * @return {boolean} True if all elements are included, false otherwise
     */
    isSubsetOf(t) {
      return this.findIndex((e) => !t.has(e)) == -1;
    }
    /**
     * Check if all elements from comparison set are included in this set
     * @param {ASet<T>} set Set to compare against
     * @return {boolean} True if all elements are included, false otherwise
     */
    isSuperset(t) {
      return t.findIndex((e) => !this.has(e)) == -1;
    }
    /**
     * Create list of elements that are only in one set but not both (XOR)
     * @param {ASet<T>} set Set to compare against
     * @return {ASet<T>} New set of unique elements
     */
    symmetricDifference(t) {
      return new E([...this.difference(t), ...t.difference(this)]);
    }
    /**
     * Create joined list of elements included in this & the comparison set
     * @param {ASet<T>} set Set join
     * @return {ASet<T>} New set of both previous sets combined
     */
    union(t) {
      return new E([...this, ...t]);
    }
  }
  class Gt {
    /**
     * Create new cache
     *
     * @param {keyof T} key Default property to use as primary key
     * @param {number} ttl Default expiry in milliseconds
     */
    constructor(t, e) {
      c(this, "store", {});
      c(this, "complete", false);
      c(this, "values", this.all());
      return this.key = t, this.ttl = e, new Proxy(this, {
        get: (r, s) => s in r ? r[s] : r.store[s],
        set: (r, s, i) => (s in r ? r[s] = i : r.store[s] = i, true)
      });
    }
    getKey(t) {
      if (!this.key) throw new Error("No key defined");
      return t[this.key];
    }
    /**
     * Get all cached items
     *
     * @return {T[]} Array of items
     */
    all() {
      return Object.values(this.store);
    }
    /**
     * Add a new item to the cache. Like set, but finds key automatically
     *
     * @param {T} value Item to add to cache
     * @param {number | undefined} ttl Override default expiry
     * @return {this}
     */
    add(t, e = this.ttl) {
      const r = this.getKey(t);
      return this.set(r, t, e), this;
    }
    /**
     * Add several rows to the cache
     *
     * @param {T[]} rows Several items that will be cached using the default key
     * @param complete Mark cache as complete & reliable, defaults to true
     * @return {this}
     */
    addAll(t, e = true) {
      return t.forEach((r) => this.add(r)), this.complete = e, this;
    }
    /**
     * Delete an item from the cache
     *
     * @param {K} key Item's primary key
     */
    delete(t) {
      delete this.store[t];
    }
    /**
     * Return cache as an array of key-value pairs
     * @return {[K, T][]} Key-value pairs array
     */
    entries() {
      return Object.entries(this.store);
    }
    /**
     * Get item from the cache
     * @param {K} key Key to lookup
     * @return {T} Cached item
     */
    get(t) {
      return this.store[t];
    }
    /**
     * Get a list of cached keys
     *
     * @return {K[]} Array of keys
     */
    keys() {
      return Object.keys(this.store);
    }
    /**
     * Get map of cached items
     *
     * @return {Record<K, T>}
     */
    map() {
      return structuredClone(this.store);
    }
    /**
     * Add an item to the cache manually specifying the key
     *
     * @param {K} key Key item will be cached under
     * @param {T} value Item to cache
     * @param {number | undefined} ttl Override default expiry
     * @return {this}
     */
    set(t, e, r = this.ttl) {
      return this.store[t] = e, r && setTimeout(() => {
        this.complete = false, this.delete(t);
      }, r), this;
    }
  }
  class O extends Promise {
    constructor(e) {
      super((r, s) => e(
        (i) => r(i),
        (i) => s(i),
        (i) => this.progress = i
      ));
      c(this, "listeners", []);
      c(this, "_progress", 0);
    }
    get progress() {
      return this._progress;
    }
    set progress(e) {
      e != this._progress && (this._progress = e, this.listeners.forEach((r) => r(e)));
    }
    static from(e) {
      return e instanceof O ? e : new O((r, s) => e.then((...i) => r(...i)).catch((...i) => s(...i)));
    }
    from(e) {
      const r = O.from(e);
      return this.onProgress((s) => r.progress = s), r;
    }
    onProgress(e) {
      return this.listeners.push(e), this;
    }
    then(e, r) {
      const s = super.then(e, r);
      return this.from(s);
    }
    catch(e) {
      return this.from(super.catch(e));
    }
    finally(e) {
      return this.from(super.finally(e));
    }
  }
  function qt(n, t) {
    n instanceof Blob || (n = new Blob(b(n)));
    const e = URL.createObjectURL(n);
    pt(e, t), URL.revokeObjectURL(e);
  }
  function pt(n, t) {
    const e = document.createElement("a");
    e.href = n, e.download = t || n.split("/").pop(), document.body.appendChild(e), e.click(), document.body.removeChild(e);
  }
  function Ft(n = {}) {
    return new Promise((t) => {
      const e = document.createElement("input");
      e.type = "file", e.accept = n.accept || "*", e.style.display = "none", e.multiple = !!n.multiple, e.onblur = e.onchange = async () => {
        t(Array.from(e.files)), e.remove();
      }, document.body.appendChild(e), e.click();
    });
  }
  function Yt(n, t = /* @__PURE__ */ new Date()) {
    (typeof t == "number" || typeof t == "string") && (t = new Date(t));
    const e = `${t.getFullYear()}-${(t.getMonth() + 1).toString().padStart(2, "0")}-${t.getDate().toString().padStart(2, "0")}_${t.getHours().toString().padStart(2, "0")}-${t.getMinutes().toString().padStart(2, "0")}-${t.getSeconds().toString().padStart(2, "0")}`;
    return e;
  }
  function Ht(n) {
    return new O((t, e, r) => {
      const s = new XMLHttpRequest(), i = new FormData();
      n.files.forEach((o) => i.append("file", o)), s.withCredentials = !!n.withCredentials, s.upload.addEventListener("progress", (o) => o.lengthComputable ? r(o.loaded / o.total) : null), s.addEventListener("loadend", () => t(k(s.responseText))), s.addEventListener("error", () => e(k(s.responseText))), s.addEventListener("timeout", () => e({ error: "Request timed out" })), s.open("POST", n.url), Object.entries(n.headers || {}).forEach(([o, u]) => s.setRequestHeader(o, u)), s.send(i);
    });
  }
  class z {
    constructor() {
      c(this, "listeners", {});
    }
    static emit(t, ...e) {
      (this.listeners["*"] || []).forEach((r) => r(t, ...e)), (this.listeners[t.toString()] || []).forEach((r) => r(...e));
    }
    static off(t, e) {
      const r = t.toString();
      this.listeners[r] = (this.listeners[r] || []).filter((s) => s === e);
    }
    static on(t, e) {
      var s;
      const r = t.toString();
      return this.listeners[r] || (this.listeners[r] = []), (s = this.listeners[r]) == null || s.push(e), () => this.off(t, e);
    }
    static once(t, e) {
      return new Promise((r) => {
        const s = this.on(t, (...i) => {
          r(i.length == 1 ? i[0] : i), e && e(...i), s();
        });
      });
    }
    emit(t, ...e) {
      (this.listeners["*"] || []).forEach((r) => r(t, ...e)), (this.listeners[t] || []).forEach((r) => r(...e));
    }
    off(t, e) {
      this.listeners[t] = (this.listeners[t] || []).filter((r) => r === e);
    }
    on(t, e) {
      var r;
      return this.listeners[t] || (this.listeners[t] = []), (r = this.listeners[t]) == null || r.push(e), () => this.off(t, e);
    }
    once(t, e) {
      return new Promise((r) => {
        const s = this.on(t, (...i) => {
          r(i.length == 1 ? i[0] : i), e && e(...i), s();
        });
      });
    }
  }
  c(z, "listeners", {});
  class g extends Error {
    constructor(e, r) {
      super(e);
      c(this, "_code");
      r != null && (this._code = r);
    }
    get code() {
      return this._code || this.constructor.code;
    }
    set code(e) {
      this._code = e;
    }
    static from(e) {
      const r = Number(e.statusCode) ?? Number(e.code), s = new this(e.message || e.toString());
      return Object.assign(s, {
        stack: e.stack,
        ...e,
        code: r ?? void 0
      });
    }
    static instanceof(e) {
      return e.constructor.code != null;
    }
    toString() {
      return this.message || super.toString();
    }
  }
  c(g, "code", 500);
  class K extends g {
    constructor(t = "Bad Request") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(K, "code", 400);
  class Z extends g {
    constructor(t = "Unauthorized") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(Z, "code", 401);
  class _ extends g {
    constructor(t = "Payment Required") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(_, "code", 402);
  class V extends g {
    constructor(t = "Forbidden") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(V, "code", 403);
  class X extends g {
    constructor(t = "Not Found") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(X, "code", 404);
  class Q extends g {
    constructor(t = "Method Not Allowed") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(Q, "code", 405);
  class tt extends g {
    constructor(t = "Not Acceptable") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(tt, "code", 406);
  class et extends g {
    constructor(t = "Internal Server Error") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(et, "code", 500);
  class nt extends g {
    constructor(t = "Not Implemented") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(nt, "code", 501);
  class rt extends g {
    constructor(t = "Bad Gateway") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(rt, "code", 502);
  class st extends g {
    constructor(t = "Service Unavailable") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(st, "code", 503);
  class it extends g {
    constructor(t = "Gateway Timeout") {
      super(t);
    }
    static instanceof(t) {
      return t.constructor.code == this.code;
    }
  }
  c(it, "code", 504);
  const m = class m2 {
    constructor(t = {}) {
      c(this, "interceptors", {});
      c(this, "headers", {});
      c(this, "url");
      this.url = t.url ?? null, this.headers = t.headers || {}, t.interceptors && t.interceptors.forEach((e) => m2.addInterceptor(e));
    }
    static addInterceptor(t) {
      const e = Object.keys(m2.interceptors).length.toString();
      return m2.interceptors[e] = t, () => {
        m2.interceptors[e] = null;
      };
    }
    addInterceptor(t) {
      const e = Object.keys(this.interceptors).length.toString();
      return this.interceptors[e] = t, () => {
        this.interceptors[e] = null;
      };
    }
    request(t = {}) {
      var s;
      if (!this.url && !t.url) throw new Error("URL needs to be set");
      let e = ((s = t.url) != null && s.startsWith("http") ? t.url : (this.url || "") + (t.url || "")).replace(/([^:]\/)\/+/g, "$1");
      if (t.fragment && (e.includes("#") ? e.replace(/#.*(\?|\n)/g, (i, o) => `#${t.fragment}${o}`) : e += "#" + t.fragment), t.query) {
        const i = Array.isArray(t.query) ? t.query : Object.keys(t.query).map((o) => ({ key: o, value: t.query[o] }));
        e += (e.includes("?") ? "&" : "?") + i.map((o) => `${o.key}=${o.value}`).join("&");
      }
      const r = lt({
        "Content-Type": t.body ? t.body instanceof FormData ? "multipart/form-data" : "application/json" : void 0,
        ...m2.headers,
        ...this.headers,
        ...t.headers
      });
      return typeof t.body == "object" && t.body != null && r["Content-Type"] == "application/json" && (t.body = JSON.stringify(t.body)), new O((i, o, u) => {
        fetch(e, {
          headers: r,
          method: t.method || (t.body ? "POST" : "GET"),
          body: t.body
        }).then(async (a) => {
          var q, F;
          for (let l of [...Object.values(m2.interceptors), ...Object.values(this.interceptors)])
            await new Promise((C) => l(a, () => C()));
          const R = a.headers.get("Content-Length"), T = R ? parseInt(R, 10) : 0;
          let U = 0;
          const M = (q = a.body) == null ? void 0 : q.getReader(), ct = new ReadableStream({
            start(l) {
              function C() {
                M == null || M.read().then((A) => {
                  if (A.done) return l.close();
                  U += A.value.byteLength, u(U / T), l.enqueue(A.value), C();
                }).catch((A) => l.error(A));
              }
              C();
            }
          });
          if (a.data = new Response(ct), t.decode == null || t.decode) {
            const l = (F = a.headers.get("Content-Type")) == null ? void 0 : F.toLowerCase();
            l != null && l.includes("form") ? a.data = await a.data.formData() : l != null && l.includes("json") ? a.data = await a.data.json() : l != null && l.includes("text") ? a.data = await a.data.text() : l != null && l.includes("application") && (a.data = await a.data.blob());
          }
          a.ok ? i(a) : o(a);
        });
      });
    }
  };
  c(m, "interceptors", {}), c(m, "headers", {});
  let H = m;
  const j = {
    CLEAR: "\x1B[0m",
    BRIGHT: "\x1B[1m",
    DIM: "\x1B[2m",
    UNDERSCORE: "\x1B[4m",
    BLINK: "\x1B[5m",
    REVERSE: "\x1B[7m",
    HIDDEN: "\x1B[8m"
  }, L = {
    BLACK: "\x1B[30m",
    RED: "\x1B[31m",
    GREEN: "\x1B[32m",
    YELLOW: "\x1B[33m",
    BLUE: "\x1B[34m",
    MAGENTA: "\x1B[35m",
    CYAN: "\x1B[36m",
    LIGHT_GREY: "\x1B[37m",
    GREY: "\x1B[90m",
    LIGHT_RED: "\x1B[91m",
    LIGHT_GREEN: "\x1B[92m",
    LIGHT_YELLOW: "\x1B[93m",
    LIGHT_BLUE: "\x1B[94m",
    LIGHT_MAGENTA: "\x1B[95m",
    LIGHT_CYAN: "\x1B[96m",
    WHITE: "\x1B[97m"
  };
  var yt = /* @__PURE__ */ ((n) => (n[n.ERROR = 0] = "ERROR", n[n.WARN = 1] = "WARN", n[n.INFO = 2] = "INFO", n[n.LOG = 3] = "LOG", n[n.DEBUG = 4] = "DEBUG", n))(yt || {});
  const w = class w2 extends z {
    constructor(t) {
      super(), this.namespace = t;
    }
    pad(t, e, r, s = false) {
      const i = t.toString(), o = e - i.length;
      if (o <= 0) return i;
      const u = Array(~~(o / r.length)).fill(r).join("");
      return s ? i + u : u + i;
    }
    format(...t) {
      const e = /* @__PURE__ */ new Date();
      return `${`${e.getFullYear()}-${e.getMonth() + 1}-${e.getDate()} ${this.pad(e.getHours().toString(), 2, "0")}:${this.pad(e.getMinutes().toString(), 2, "0")}:${this.pad(e.getSeconds().toString(), 2, "0")}.${this.pad(e.getMilliseconds().toString(), 3, "0", true)}`}${this.namespace ? ` [${this.namespace}]` : ""} ${t.join(" ")}`;
    }
    debug(...t) {
      if (w2.LOG_LEVEL < 4) return;
      const e = this.format(...t);
      w2.emit(4, e), console.debug(L.LIGHT_GREY + e + j.CLEAR);
    }
    log(...t) {
      if (w2.LOG_LEVEL < 3) return;
      const e = this.format(...t);
      w2.emit(3, e), console.log(j.CLEAR + e);
    }
    info(...t) {
      if (w2.LOG_LEVEL < 2) return;
      const e = this.format(...t);
      w2.emit(2, e), console.info(L.BLUE + e + j.CLEAR);
    }
    warn(...t) {
      if (w2.LOG_LEVEL < 1) return;
      const e = this.format(...t);
      w2.emit(1, e), console.warn(L.YELLOW + e + j.CLEAR);
    }
    error(...t) {
      if (w2.LOG_LEVEL < 0) return;
      const e = this.format(...t);
      w2.emit(0, e), console.error(L.RED + e + j.CLEAR);
    }
  };
  c(w, "LOG_LEVEL", 4);
  function ue(n, ...t) {
    const e = [];
    for (let r = 0; r < n.length || r < t.length; r++)
      n[r] && e.push(n[r]), t[r] && e.push(t[r]);
    return new y(e.join(""));
  }
  function xt(n, ...t) {
    let e = [];
    for (let i = 0; i < n.length || i < t.length; i++)
      n[i] && e.push(n[i]), t[i] && e.push(t[i]);
    const [r, s] = e.join("").split(":");
    return y.toString(r, s == null ? void 0 : s.split(""));
  }
  class y {
    constructor(t) {
      c(this, "module");
      c(this, "fullPath");
      c(this, "path");
      c(this, "name");
      c(this, "methods");
      c(this, "all");
      c(this, "none");
      c(this, "create");
      c(this, "read");
      c(this, "update");
      c(this, "delete");
      var o;
      if (typeof t == "object") return Object.assign(this, t);
      let [e, r, s] = t.split(":");
      s || (s = r || "*"), (e == "*" || !e && s == "*") && (e = "", s = "*");
      let i = e.split("/").filter((u) => !!u);
      this.module = ((o = i.splice(0, 1)[0]) == null ? void 0 : o.toLowerCase()) || "", this.fullPath = e, this.path = i.join("/"), this.name = i.pop() || "", this.methods = s.split(""), this.all = s == null ? void 0 : s.includes("*"), this.none = s == null ? void 0 : s.includes("n"), this.create = !(s != null && s.includes("n")) && ((s == null ? void 0 : s.includes("*")) || (s == null ? void 0 : s.includes("w")) || (s == null ? void 0 : s.includes("c"))), this.read = !(s != null && s.includes("n")) && ((s == null ? void 0 : s.includes("*")) || (s == null ? void 0 : s.includes("r"))), this.update = !(s != null && s.includes("n")) && ((s == null ? void 0 : s.includes("*")) || (s == null ? void 0 : s.includes("w")) || (s == null ? void 0 : s.includes("u"))), this.delete = !(s != null && s.includes("n")) && ((s == null ? void 0 : s.includes("*")) || (s == null ? void 0 : s.includes("w")) || (s == null ? void 0 : s.includes("d")));
    }
    /**
     * Combine multiple  events into one parsed object. Longest path takes precedent, but all subsequent methods are
     * combined until a "none" is reached
     *
     * @param {string | PathEvent} paths Events as strings or pre-parsed
     * @return {PathEvent} Final combined permission
     */
    static combine(t) {
      let e = false;
      const r = t.map((s) => new y(s)).toSorted((s, i) => {
        const o = s.fullPath.length, u = i.fullPath.length;
        return o < u ? 1 : o > u ? -1 : 0;
      }).reduce((s, i) => (i.none && (e = true), s ? (e || (i.all && (s.all = true), (i.all || i.create) && (s.create = true), (i.all || i.read) && (s.read = true), (i.all || i.update) && (s.update = true), (i.all || i.delete) && (s.delete = true), s.methods = [...s.methods, ...i.methods]), s) : i), null);
      return r.all && (r.methods = ["*"]), r.none && (r.methods = ["n"]), r.methods = new E(r.methods), r.raw = xt`${r.fullPath}:${r.methods}`, r;
    }
    /**
     * Squash 2 sets of paths & return true if any overlap is found
     *
     * @param {string | PathEvent | (string | PathEvent)[]} target Array of Events as strings or pre-parsed
     * @param has Target must have at least one of these path
     * @return {boolean} Whether there is any overlap
     */
    static has(t, ...e) {
      const r = b(e).map((i) => new y(i)), s = b(t).map((i) => new y(i));
      return !!r.find((i) => {
        if (!i.fullPath && i.all) return true;
        const o = s.filter((a) => i.fullPath.startsWith(a.fullPath));
        if (!o.length) return false;
        const u = y.combine(o);
        return !u.none && (u.all || new E(u.methods).intersection(new E(i.methods)).length);
      });
    }
    /**
     * Squash 2 sets of paths & return true if the target has all paths
     *
     * @param {string | PathEvent | (string | PathEvent)[]} target Array of Events as strings or pre-parsed
     * @param has Target must have all these paths
     * @return {boolean} Whether there is any overlap
     */
    static hasAll(t, ...e) {
      return e.filter((r) => y.has(t, r)).length == e.length;
    }
    /**
     * Same as `has` but raises an error if there is no overlap
     *
     * @param {string | string[]} target Array of Events as strings or pre-parsed
     * @param has Target must have at least one of these path
     */
    static hasFatal(t, ...e) {
      if (!y.has(t, ...e)) throw new Error(`Requires one of: ${b(e).join(", ")}`);
    }
    /**
     * Same as `hasAll` but raises an error if the target is missing any paths
     *
     * @param {string | string[]} target Array of Events as strings or pre-parsed
     * @param has Target must have all these paths
     */
    static hasAllFatal(t, ...e) {
      if (!y.hasAll(t, ...e)) throw new Error(`Requires all: ${b(e).join(", ")}`);
    }
    /**
     * Create  event string from its components
     *
     * @param {string | string[]} path Event path
     * @param {Method} methods Event method
     * @return {string} String representation of Event
     */
    static toString(t, e) {
      let r = b(t).filter((s) => s != null).join("/");
      return e != null && e.length && (r += `:${b(e).map((s) => s.toLowerCase()).join("")}`), r == null ? void 0 : r.trim().replaceAll(/\/{2,}/g, "/").replaceAll(/(^\/|\/$)/g, "");
    }
    /**
     * Create  event string from its components
     *
     * @return {string} String representation of Event
     */
    toString() {
      return y.toString(this.fullPath, this.methods);
    }
  }
  class ae {
    constructor() {
      c(this, "listeners", []);
    }
    emit(t, ...e) {
      const r = new y(t);
      this.listeners.filter((s) => y.has(s[0], t)).forEach(async (s) => s[1](r, ...e));
    }
    off(t) {
      this.listeners = this.listeners.filter((e) => e[1] != t);
    }
    on(t, e) {
      return b(t).forEach((r) => this.listeners.push([new y(r), e])), () => this.off(e);
    }
    once(t, e) {
      return new Promise((r) => {
        const s = this.on(t, (i, ...o) => {
          r(o.length < 2 ? o[0] : o), e && e(i, ...o), s();
        });
      });
    }
    relayEvents(t) {
      t.on("*", (e, ...r) => this.emit(e, ...r));
    }
  }
  var v = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {}, At = {}, B = {};
  Object.defineProperty(B, "__esModule", { value: true });
  B.persist = B.Persist = void 0;
  class ot {
    /**
     * @param {string} key Primary key value will be stored under
     * @param {PersistOptions<T>} options Configure using {@link PersistOptions}
     */
    constructor(t, e = {}) {
      c(this, "key");
      c(this, "options");
      c(this, "storage");
      c(this, "watches", {});
      c(this, "_value");
      this.key = t, this.options = e, this.storage = e.storage || localStorage, this.load();
    }
    /** Current value or default if undefined */
    get value() {
      var t;
      return this._value !== void 0 ? this._value : (t = this.options) == null ? void 0 : t.default;
    }
    /** Set value with proxy object wrapper to sync future changes */
    set value(t) {
      t == null || typeof t != "object" ? this._value = t : this._value = new Proxy(t, {
        get: (e, r) => typeof e[r] == "function" ? (...i) => {
          const o = e[r](...i);
          return this.save(), o;
        } : e[r],
        set: (e, r, s) => (e[r] = s, this.save(), true)
      }), this.save();
    }
    /** Notify listeners of change */
    notify(t) {
      Object.values(this.watches).forEach((e) => e(t));
    }
    /** Delete value from storage */
    clear() {
      this.storage.removeItem(this.key);
    }
    /** Save current value to storage */
    save() {
      this._value === void 0 ? this.clear() : this.storage.setItem(this.key, JSON.stringify(this._value)), this.notify(this.value);
    }
    /** Load value from storage */
    load() {
      if (this.storage[this.key] != null) {
        let t = JSON.parse(this.storage.getItem(this.key));
        t != null && typeof t == "object" && this.options.type && (t.__proto__ = this.options.type.prototype), this.value = t;
      } else
        this.value = this.options.default || void 0;
    }
    /**
     * Callback function which is run when there are changes
     *
     * @param {(value: T) => any} fn Callback will run on each change; it's passed the next value & it's return is ignored
     * @returns {() => void} Function which will unsubscribe the watch/callback when called
     */
    watch(t) {
      const e = Object.keys(this.watches).length;
      return this.watches[e] = t, () => {
        delete this.watches[e];
      };
    }
    /**
     * Return value as JSON string
     *
     * @returns {string} Stringified object as JSON
     */
    toString() {
      return JSON.stringify(this.value);
    }
    /**
     * Return current value
     *
     * @returns {T} Current value
     */
    valueOf() {
      return this.value;
    }
  }
  B.Persist = ot;
  function jt(n) {
    return (t, e) => {
      const r = (n == null ? void 0 : n.key) || `${t.constructor.name}.${e.toString()}`, s = new ot(r, n);
      Object.defineProperty(t, e, {
        get: function() {
          return s.value;
        },
        set: function(i) {
          s.value = i;
        }
      });
    };
  }
  B.persist = jt;
  var I = {};
  Object.defineProperty(I, "__esModule", { value: true });
  I.MemoryStorage = void 0;
  class $t {
    get length() {
      return Object.keys(this).length;
    }
    clear() {
      Object.keys(this).forEach((t) => this.removeItem(t));
    }
    getItem(t) {
      return this[t];
    }
    key(t) {
      return Object.keys(this)[t];
    }
    removeItem(t) {
      delete this[t];
    }
    setItem(t, e) {
      this[t] = e;
    }
  }
  I.MemoryStorage = $t;
  (function(n) {
    var t = v && v.__createBinding || (Object.create ? function(r, s, i, o) {
      o === void 0 && (o = i);
      var u = Object.getOwnPropertyDescriptor(s, i);
      (!u || ("get" in u ? !s.__esModule : u.writable || u.configurable)) && (u = { enumerable: true, get: function() {
        return s[i];
      } }), Object.defineProperty(r, o, u);
    } : function(r, s, i, o) {
      o === void 0 && (o = i), r[o] = s[i];
    }), e = v && v.__exportStar || function(r, s) {
      for (var i in r) i !== "default" && !Object.prototype.hasOwnProperty.call(s, i) && t(s, r, i);
    };
    Object.defineProperty(n, "__esModule", { value: true }), e(B, n), e(I, n);
  })(At);
  class Api extends H {
    constructor(url = location.origin, opts = {}) {
      opts.url = url;
      super(opts);
      __publicField(this, "emitter", new ae());
      __publicField(this, "pending", {});
      __publicField(this, "_token", null);
      __publicField(this, "emit", this.emitter.emit.bind(this.emitter));
      __publicField(this, "off", this.emitter.off.bind(this.emitter));
      __publicField(this, "on", this.emitter.on.bind(this.emitter));
      __publicField(this, "once", this.emitter.once.bind(this.emitter));
      __publicField(this, "relayEvents", this.emitter.relayEvents.bind(this.emitter));
      this.url = url;
      this.opts = opts;
    }
    get token() {
      return this._token;
    }
    set token(token) {
      if (token == this._token) return;
      this._token = token;
      this.headers["Authorization"] = token ? `Bearer ${token}` : null;
      this.emit(xt`api/token:${token ? "u" : "d"}`, token);
    }
    healthcheck() {
      return this.request({ url: "/api/healthcheck" }).then((resp) => {
        this.emit(xt`api/healthcheck:r`, resp);
        return resp;
      });
    }
    request(options) {
      const key = It(options);
      const method = options.method == "GET" ? "r" : options.method == "POST" ? "c" : options.method == "DELETE" ? "d" : "u";
      if (this.pending[key] != null) return this.pending[key];
      this.pending[key] = super.request(options).then((response) => {
        this.emit(xt`api/response:${method}`, { request: options, response });
        return response.data;
      }).catch((err) => {
        const e = (err == null ? void 0 : err.data) || err;
        this.emit(xt`api/error:${method}`, { request: options, error: e });
        throw e;
      }).finally(() => delete this.pending[key]);
      this.emit(xt`api/request:${method}`, { request: options, response: this.pending[key] });
      return this.pending[key];
    }
  }
  var ActionType = /* @__PURE__ */ ((ActionType2) => {
    ActionType2[ActionType2["CRON"] = 0] = "CRON";
    ActionType2[ActionType2["EVENT"] = 1] = "EVENT";
    ActionType2[ActionType2["DELETE"] = 2] = "DELETE";
    ActionType2[ActionType2["GET"] = 3] = "GET";
    ActionType2[ActionType2["PATCH"] = 4] = "PATCH";
    ActionType2[ActionType2["POST"] = 5] = "POST";
    ActionType2[ActionType2["PUT"] = 6] = "PUT";
    return ActionType2;
  })(ActionType || {});
  class Actions extends ae {
    constructor(api) {
      super();
      __publicField(this, "api");
      __publicField(this, "cache", new Gt("_id"));
      this.api = typeof api == "string" ? new Api(api) : api;
    }
    all() {
      return this.api.request({ url: `/api/` + xt`actions` }).then((resp) => {
        this.cache.addAll(resp);
        this.emit(xt`actions:r`, resp || []);
        return resp;
      });
    }
    delete(id) {
      if (!id) throw new Error("Cannot delete action, missing ID");
      return this.api.request({ url: `/api/` + xt`actions/${id}`, method: "DELETE" }).then(() => {
        this.cache.delete(id);
        this.emit(xt`actions/${id}:d`, id);
      });
    }
    read(id, reload = false) {
      if (!id) throw new Error("Cannot read action, missing ID");
      const cached = this.cache.get(id);
      if (!reload && cached) return Promise.resolve(cached);
      return this.api.request({ url: `/api/` + xt`actions/${id}` }).then((action) => {
        if (action) this.cache.add(action);
        this.emit(xt`actions/${id}:r`, action);
        return action;
      });
    }
    run(path, opts = {}) {
      if (!path) throw new Error("Cannot run action, missing path");
      return this.api.request({ url: `/api/` + xt`actions/run/${path}`, ...opts });
    }
    runById(action, opts = {}) {
      const id = typeof action == "string" ? action : action == null ? void 0 : action._id;
      if (!id) throw new Error("Cannot run action, missing ID");
      return this.api.request({ url: "/api/" + xt`actions/run-by-id/${id}`, method: "POST", ...opts });
    }
    update(action) {
      return this.api.request({
        url: `/api/` + xt`actions/${action._id}`,
        method: "POST",
        body: action
      }).then((action2) => {
        if (action2) this.cache.add(action2);
        this.emit(xt`actions/${action2._id}:u`, action2);
        return action2;
      });
    }
  }
  class Ai extends ae {
    constructor(api) {
      super();
      __publicField(this, "api");
      this.api = typeof api == "string" ? new Api(api) : api;
    }
    ask(question, context) {
      if (!question) throw new Error("Cannot ask AI, missing question");
      return this.api.request({ url: `/api/` + xt`ai`, method: "POST", body: {
        question,
        context
      } }).then((response) => {
        this.emit(xt`ai:c`, { question, context, response });
        return response;
      });
    }
    clear() {
      return this.api.request({ url: "/api/" + xt`ai`, method: "DELETE" }).then(() => this.emit(xt`ai:d`, this.api.token));
    }
  }
  class Analytics extends ae {
    constructor(api) {
      super();
      __publicField(this, "api");
      this.api = typeof api == "string" ? new Api(api) : api;
    }
    ipTrace(ip) {
      if (!ip) throw new Error("Cannot trace, missing IP");
      return this.api.request({ url: `/api/` + xt`analytics/trace/${ip}` }).then((resp) => {
        this.emit(xt`analytics/trace/${ip}:r`, resp);
        return resp;
      });
    }
  }
  class Auth extends ae {
    constructor(api, opts = {}) {
      super();
      __publicField(this, "api");
      __publicField(this, "storageKey");
      __publicField(this, "_user");
      __publicField(this, "enableTotp", this.resetTotp);
      this.opts = opts;
      this.api = typeof api == "string" ? new Api(api) : api;
      this.opts = {
        loginUrl: this.api.url + "/ui/#/login",
        persist: true,
        ...this.opts
      };
      this.storageKey = `momentum:${new URL(this.api.url).host}`;
      this.api.addInterceptor((resp, next) => {
        const blacklist = [
          "/api/auth/login",
          "/api/auth/password",
          "/api/auth/totp"
        ];
        if (resp.status == 401 && !blacklist.find((url) => resp.url.includes(url)))
          this.emit(xt`auth/session-expired:d`, this.api.token);
        next();
      });
      this.api.on("api/token", (event, token) => {
        var _a;
        if ((_a = this.opts) == null ? void 0 : _a.persist) {
          if (token) localStorage.setItem(this.storageKey, token);
          else localStorage.removeItem(this.storageKey);
        }
        if (token) this.session(token, true).catch(() => {
        });
        else this.user = null;
      });
      if (opts == null ? void 0 : opts.persist) {
        const token = localStorage.getItem(this.storageKey);
        if (token) this.api.token = token;
        else this.user = null;
      } else {
        this.user = null;
      }
    }
    get user() {
      return this._user;
    }
    set user(user) {
      if (!$(this.user, user)) {
        this._user = user ? user : null;
        this.emit(xt`auth/user:u`, this._user);
      }
    }
    knownHost(host = location.origin) {
      if (host.startsWith("/")) return Promise.resolve();
      return this.api.request({ url: `/api/auth/known-host?host=${encodeURI(new URL(host).origin)}` });
    }
    login(username, password, totp) {
      if (!username || !password) throw new Error("Cannot login, missing username or password");
      return this.api.request({
        url: "/api/auth/login",
        headers: { Authorization: void 0 },
        method: "POST",
        body: {
          username: username.trim(),
          password: password.trim(),
          totp
        }
      }).then(async (resp) => {
        this.api.token = (resp == null ? void 0 : resp.token) || null;
        const user = await this.once("auth/user");
        this.emit(xt`auth/login/${username}:u`, user);
        return user;
      });
    }
    loginRedirect(host = location.origin) {
      return new Promise((res, rej) => {
        var _a;
        const win = window.open(encodeURI(`${(_a = this.opts) == null ? void 0 : _a.loginUrl}?redirect=postmessage&host=${host}`), "_blank");
        if (!win) return rej("Unable to open login");
        const origin = new URL(this.opts.loginUrl).origin;
        win.addEventListener("message", (event) => {
          const data = (event == null ? void 0 : event.data) || {};
          if (event.origin != data.sender || data.sender != origin) return;
          if (!data.token) return rej("Unknown response from login");
          this.api.token = event.data.token;
          res(event.data.token);
          win.close();
        });
      });
    }
    logout() {
      this.emit(xt`auth/logout:d`, this.user);
      this.api.token = null;
      this.user = null;
    }
    async register(u) {
      var _a;
      if (!u.username || !u.password) throw new Error("Cannot register user, missing username or password");
      const user = await this.api.request({ url: "/api/auth/register", body: { ...u } });
      if ((_a = user == null ? void 0 : user.image) == null ? void 0 : _a.startsWith("/")) user.image = `${this.api.url}${user.image}?token=${this.api.token}`;
      this.emit(xt`auth/register:c`, user);
      return user;
    }
    reset(emailOrPass, token) {
      if (!emailOrPass) throw new Error("Cannot reset password, missing email or token");
      return this.api.request({
        url: "/api/auth/reset",
        headers: { "Authorization": token ? `Bearer ${token}` : void 0 },
        body: {
          email: token ? void 0 : emailOrPass,
          password: token ? emailOrPass : void 0
        }
      }).then(() => {
        this.emit(xt`auth/reset:${token ? "u" : "c"}`, token || emailOrPass);
      });
    }
    async session(token, set = false) {
      if (!token) token = this.api.token;
      const session = await this.api.request({
        url: "/api/auth/session",
        headers: token ? { "Authorization": `Bearer ${token}` } : void 0
      });
      this.emit(xt`auth/session:r`, session);
      if (set) {
        this.api.token = token;
        if (session == null ? void 0 : session.user) session.user.image = `${this.api.url}${session.user.image}?token=${this.api.token}`;
        this.user = (session == null ? void 0 : session.user) || null;
        if (session) this.emit(xt`auth/login:c`, session.user);
      }
      return session;
    }
    async updatePassword(username, password, oldPassword) {
      if (!username || !password) throw new Error("Cannot update password, missing username or password");
      return this.api.request({
        url: "/api/auth/password",
        body: { username, password, oldPassword }
      }).then((resp) => {
        this.emit(xt`auth/reset:u`, resp == null ? void 0 : resp.token);
        if (resp == null ? void 0 : resp.token) this.api.token = resp.token;
      });
    }
    // TOTP ============================================================================================================
    disableTotp(username) {
      return this.api.request({ url: `/api/auth/totp/${username}`, method: "DELETE" });
    }
    resetTotp(username) {
      return this.api.request({ url: `/api/auth/totp/${username}`, method: "POST" });
    }
    setupTotp(username, method = "app", totp) {
      return this.api.request({ url: `/api/auth/totp/${username}`, body: lt({
        method,
        totp
      }) });
    }
  }
  class Client extends ae {
    constructor(settings) {
      super();
      __publicField(this, "_platform");
      __publicField(this, "_pwa");
      this.settings = settings;
    }
    get mobile() {
      return ["android", "ios"].includes(this.platform);
    }
    get platform() {
      if (!this._platform) {
        const userAgent = navigator.userAgent || navigator.vendor;
        if (/windows/i.test(userAgent)) this._platform = "windows";
        else if (/android/i.test(userAgent)) this._platform = "android";
        else if (/iPad|iPhone|iPod/.test(userAgent)) this._platform = "ios";
        else if (/macintosh|mac os x/i.test(userAgent)) this._platform = "mac";
        else if (/linux/i.test(userAgent)) this._platform = "linux";
        else this._platform = "unknown";
      }
      return this._platform;
    }
    get pwa() {
      if (this._pwa == null)
        this._pwa = window.matchMedia("(display-mode: standalone)").matches || (navigator == null ? void 0 : navigator.standalone) || document.referrer.includes("android-app://");
      return this._pwa;
    }
    async inject(reload = false) {
      var _a, _b, _c, _d, _e, _f, _g, _h;
      const settings = await this.settings.all(false, reload);
      if (!document.querySelector('meta[name="mobile-web-app-capable"]')) {
        const meta = document.createElement("meta");
        meta.name = "mobile-web-app-capable";
        meta.content = "yes";
        document.head.append(meta);
      }
      if (!document.querySelector('meta[name="apple-mobile-web-app-status-bar-style"]')) {
        const meta = document.createElement("meta");
        meta.name = "apple-mobile-web-app-status-bar-style";
        meta.content = "default";
        document.head.append(meta);
      }
      if (!document.querySelector('meta[name="apple-mobile-web-app-title"]')) {
        const meta = document.createElement("meta");
        meta.name = "apple-mobile-web-app-title";
        meta.content = settings["title"];
        document.head.append(meta);
      }
      if (!document.querySelector('link[rel="apple-touch-icon"]')) {
        const meta = document.createElement("link");
        meta.rel = "apple-touch-icon";
        meta.href = settings["logo"];
        document.head.append(meta);
      }
      if (!document.querySelector('link[rel="apple-touch-startup-image"]')) {
        const meta = document.createElement("link");
        meta.rel = "apple-touch-startup-image";
        meta.href = settings["logo"];
        document.head.append(meta);
      }
      window.document.body.classList.add(((_a = settings["theme"]) == null ? void 0 : _a.darkMode) ? "theme-dark" : "theme-light");
      window.document.body.classList.remove(((_b = settings["theme"]) == null ? void 0 : _b.darkMode) ? "theme-light" : "theme-dark");
      if (settings["title"])
        window.document.querySelectorAll(".momentum-title").forEach((el) => el.innerText = settings["title"]);
      if (settings["description"])
        window.document.querySelectorAll(".momentum-description").forEach((el) => el.innerText = settings["description"]);
      if (settings.version)
        window.document.querySelectorAll(".momentum-version").forEach((el) => el.innerText = settings["version"]);
      if (settings["logo"]) {
        window.document.querySelectorAll(".momentum-logo").forEach((el) => {
          el.src = settings["logo"];
          el.href = settings["logo"];
        });
      }
      if (settings["theme"]) {
        let style = window.document.querySelector("#momentum-theme");
        if (!style) {
          style = window.document.createElement("style");
          style.id = "momentum-theme";
          window.document.head.append(style);
        }
        style.innerHTML = `
			:root {
				--theme-bg-primary: ${(_c = settings["theme"]) == null ? void 0 : _c.background};
				--theme-bg-secondary: ${((_d = settings["theme"]) == null ? void 0 : _d.darkMode) ? "#2e2e2e" : "#ffffff"};
				--theme-primary: ${(_e = settings["theme"]) == null ? void 0 : _e.primary};
				--theme-secondary: ${(_f = settings["theme"]) == null ? void 0 : _f.secondary};
				--theme-text: ${((_g = settings["theme"]) == null ? void 0 : _g.darkMode) ? "#ffffff" : "#000000"};
				--theme-muted: ${((_h = settings["theme"]) == null ? void 0 : _h.darkMode) ? "#cccccc" : "#6c757d"};
			}`;
      }
      if (settings["pwa"]) {
        const link = window.document.createElement("link");
        link.setAttribute("rel", "manifest");
        link.setAttribute("href", this.settings.api.url + "/manifest.json");
        window.document.head.append(link);
        setTimeout(() => {
          const dismissed = !!localStorage.getItem("momentum:install-prompt");
          if (!dismissed && !this.pwa && this.mobile) this.pwaPrompt();
        }, 500);
      }
      this.emit(xt`client/inject:c`, this.platform);
    }
    pwaPrompt(platform) {
      const url = this.settings.api.url;
      const settings = this.settings.cache;
      const android = (platform || this.platform) == "android";
      let style = document.querySelector("style.momentum-pwa");
      if (!style) {
        style = document.createElement("style");
        style.innerHTML = `
		.momentum-pwa-prompt-backdrop {
			position: fixed;
			display: relative;
			left: 0;
			top: 0;
			right: 0;
			bottom: 0;
			background: rgba(0,0,0,.5);
			z-index: 9999;
			animation: fadeIn 0.5s ease-in-out forwards;
			opacity: 0;
		}
		.momentum-pwa-prompt-backdrop.exit {
			animation: fadeOut 0.5s ease-in-out forwards !important;
		}
		.momentum-pwa-prompt {
			position: fixed;
			background: #fff;
			color: black;
			bottom: 0;
			left: 50%;
			width: min(100vw, 450px);
			transform: translate(-50%, 0);
			animation: slideUp 0.5s ease-in-out forwards;
		}
		.momentum-pwa-prompt.exit {
			animation: slideDown 0.5s ease-in-out forwards !important;
		}
		.momentum-pwa-prompt img {
			width: 18px;
			height: 18px;
		}
		.momentum-pwa-prompt h1 {
			font-size: 1.25rem;
			font-weight: bold;
		}
		.momentum-pwa-prompt-close {
			position: absolute;
			right: 5px;
			top: 10px;
			background: transparent;
			border: none;
			cursor: pointer;
		}

		@keyframes fadeIn {
		  from { opacity: 0; }
		  to { opacity: 1; }
		}
		@keyframes fadeOut {
		  from { opacity: 1; }
		  to { opacity: 0; }
		}

		@keyframes slideUp {
		  from { transform: translate(-50%, 100%); }
		  to { transform: translate(-50%, 0); }
		}
		@keyframes slideDown {
		  from { transform: translate(-50%, 0); }
		  to { transform: translate(-50%, 100%); }
		}
		`;
        document.head.append(style);
      }
      const backdrop = document.createElement("div");
      backdrop.classList.add("momentum-pwa-prompt-backdrop");
      const prompt = document.createElement("div");
      prompt.classList.add("momentum-pwa-prompt");
      prompt.innerHTML = `
			<div style="display: flex; padding: 1rem; align-items: center">
			  <img src="${url}${settings.logo}" alt="Logo" style="height: 30px; width: auto; margin-right: .5rem;" />
			  <h1 style="margin: 0">Install ${settings.title}</h1>
			</div>
			<div style="display: flex; flex-direction: column; align-items: center">
			  <div style="border-top: 2px solid #00000020; border-bottom: 2px solid #00000020; padding: 0 1rem">
				<p style="margin-top: 1rem; text-align: center">This website can be installed as an App! Add it to your home screen for quick access & fullscreen use.</p>
			  </div>
			  <table style="margin: 1.5rem 0">
				<tr>
				  <td style="width: 50px; text-align: center">
				    ${android ? '<svg xmlns="http://www.w3.org/2000/svg" height="24px" viewBox="0 -960 960 960" width="24px" fill="black" style="transform: scale(1.5)"><path d="M480-160q-33 0-56.5-23.5T400-240q0-33 23.5-56.5T480-320q33 0 56.5 23.5T560-240q0 33-23.5 56.5T480-160Zm0-240q-33 0-56.5-23.5T400-480q0-33 23.5-56.5T480-560q33 0 56.5 23.5T560-480q0 33-23.5 56.5T480-400Zm0-240q-33 0-56.5-23.5T400-720q0-33 23.5-56.5T480-800q33 0 56.5 23.5T560-720q0 33-23.5 56.5T480-640Z"/></svg>' : '<svg viewBox="0 0 566 670" xmlns="http://www.w3.org/2000/svg" fill="#0B76FC" height="40px"><path d="M255 12c4-4 10-8 16-8s12 3 16 8l94 89c3 4 6 7 8 12 2 6 0 14-5 19-7 8-20 9-28 2l-7-7-57-60 2 54v276c0 12-10 22-22 22-12 1-24-10-23-22V110l1-43-60 65c-5 5-13 8-21 6a19 19 0 0 1-16-17c-1-7 2-13 7-18l95-91z" /><path d="M43 207c16-17 40-23 63-23h83v46h-79c-12 0-25 3-33 13-8 9-10 21-10 33v260c0 13 0 27 6 38 5 12 18 18 30 19l14 1h302c14 0 28 0 40-8 11-7 16-21 16-34V276c0-11-2-24-9-33-8-10-22-13-34-13h-78v-46h75c13 0 25 1 37 4 16 4 31 13 41 27 11 17 14 37 14 57v280c0 20-3 41-15 58a71 71 0 0 1-45 27c-11 2-23 3-34 3H109c-19-1-40-4-56-15-14-9-23-23-27-38-4-12-5-25-5-38V270c1-22 6-47 22-63z" /></svg>'}
				  </td>
				  <td>
					<p style="margin: 1rem 0">1) ${android ? "Open the dropdown menu" : 'Press the "Share" button'}</p>
				  </td>
				</tr>
				<tr>
				  <td style="width: 50px; text-align: center">
				    ${android ? '<svg xmlns="http://www.w3.org/2000/svg" height="24px" viewBox="0 -960 960 960" width="24px" fill="black" style="transform: scale(-1.5, 1.5)"><path d="M280-40q-33 0-56.5-23.5T200-120v-720q0-33 23.5-56.5T280-920h280v80H280v40h280v80H280v480h400v-80h80v200q0 33-23.5 56.5T680-40H280Zm0-120v40h400v-40H280Zm440-240L520-600l56-56 104 104v-288h80v288l104-104 56 56-200 200ZM280-800v-40 40Zm0 640v40-40Z"/></svg>' : '<svg viewBox="0 0 578 584" xmlns="http://www.w3.org/2000/svg" fill="black" height="34px"><path d="M101 35l19-1h333c12 0 23 0 35 3 17 3 34 12 44 27 13 16 16 38 16 58v329c0 19 0 39-8 57a65 65 0 0 1-37 37c-18 7-38 7-57 7H130c-21 1-44 0-63-10-14-7-25-20-30-34-6-15-8-30-8-45V121c1-21 5-44 19-61 13-16 33-23 53-25m7 46c-10 1-19 6-24 14-7 8-9 20-9 31v334c0 12 2 25 10 34 9 10 23 12 35 12h336c14 1 30-3 38-15 6-9 8-20 8-31V125c0-12-2-24-10-33-9-9-22-12-35-12H121l-13 1z" /><path d="M271 161c9-11 31-10 38 4 3 5 3 11 3 17v87h88c7 0 16 1 21 7 6 6 7 14 6 22a21 21 0 0 1-10 14c-5 4-11 5-17 5h-88v82c0 7-1 15-6 20-10 10-29 10-37-2-3-6-4-13-4-19v-81h-87c-8-1-17-3-23-9-5-6-6-15-4-22a21 21 0 0 1 11-14c6-3 13-3 19-3h84v-88c0-7 1-14 6-20z" /></svg>'}
				  </td>
				  <td>
					<p style="margin: 1rem 0">2) Press "Add to Home Screen"</p>
				  </td>
				</tr>
			  </table>
			</div>`;
      const close = document.createElement("button");
      close.classList.add("momentum-pwa-prompt-close");
      close.innerText = "X";
      close.onclick = () => {
        prompt.classList.add("exit");
        backdrop.classList.add("exit");
        localStorage.setItem("momentum:install-prompt", "dismissed");
        setTimeout(() => {
          prompt.remove();
          backdrop.remove();
          this.emit(xt`client/pwa:d`, platform);
        }, 500);
      };
      prompt.append(close);
      backdrop.append(prompt);
      document.body.append(backdrop);
      this.emit(xt`client/pwa:c`, platform);
    }
  }
  class Data extends ae {
    constructor(api) {
      super();
      __publicField(this, "api");
      this.api = typeof api == "string" ? new Api(api) : api;
    }
    create(collection, document2) {
      if (!collection || !document2) throw new Error("Cannot create document, missing collection or document");
      return this.api.request({
        url: `/api/` + xt`data/${collection}`,
        method: "POST",
        body: document2
      }).then((resp) => {
        this.emit(xt`data/${collection}:c`, resp);
        return resp;
      });
    }
    delete(collection, id) {
      if (!collection || !id) throw new Error("Cannot delete document, missing collection or ID");
      return this.api.request({
        url: `/api/` + xt`data/${collection}/${id}`,
        method: "DELETE"
      }).then(() => this.emit(xt`data/${collection}/${id}:d`, id));
    }
    read(collection, id) {
      if (!collection) throw new Error("Cannot read documents, missing collection");
      return this.api.request({ url: `/api/` + xt`data/${collection}/${id}` }).then((resp) => {
        this.emit(xt`data/${collection}/${id}:r`, collection, resp);
        return resp;
      });
    }
    update(collection, document2, append = true) {
      if (!collection || !document2) throw new Error("Cannot update document, missing collection or document");
      if (!document2._id) return this.create(collection, document2);
      return this.api.request({
        url: `/api/` + xt`data/${collection}/${document2._id}`,
        method: append ? "PATCH" : "PUT",
        body: document2
      }).then((resp) => {
        this.emit(xt`data/${collection}/${document2._id}:u`, resp);
        return resp;
      });
    }
    raw(collection, query) {
      if (!collection || !query) throw new Error("Cannot execute raw query, missing collection or query");
      const mode = query.operand.startsWith("find") ? "r" : query.operand == "insert" ? "c" : query.operand.startsWith("delete") ? "d" : "u";
      return this.api.request({ url: `/api/` + xt`data/${collection}` + "?raw", body: query }).then((resp) => {
        this.emit(xt`data/${collection}:${mode}`, resp);
        return resp;
      });
    }
    // Schema ==========================================================================================================
    deleteSchema(path) {
      if (!path) throw new Error("Cannot delete schema, missing collection path");
      return this.api.request({ url: `/api/` + xt`schema/${path}`, method: "DELETE" }).then(() => this.emit(xt`schema/${path}:d`, path));
    }
    readSchema(pathOrTree) {
      return this.api.request({ url: "/api/" + xt`schema/${typeof pathOrTree == "string" ? pathOrTree : ""}` + (pathOrTree === true ? `?tree=${pathOrTree}` : "") }).then((resp) => {
        this.emit(xt`schema/${typeof pathOrTree == "string" ? pathOrTree : ""}:r`, resp);
        return resp;
      });
    }
    updateSchema(schema) {
      if (!schema.path) throw new Error("Cannot update schema, missing collection path");
      return this.api.request({ url: "/api/" + xt`schema/${schema.path}`, body: schema }).then((resp) => {
        this.emit(xt`schema/${schema.path}:${schema._id ? "u" : "c"}`, resp);
        return resp;
      });
    }
  }
  class Email extends ae {
    constructor(api) {
      super();
      __publicField(this, "api");
      this.api = typeof api == "string" ? new Api(api) : api;
    }
    send(email) {
      var _a;
      if (!email.to && !email.bcc || !email.body) throw new Error("Cannot send email, missing address or body");
      return this.api.request({ url: "/api/" + xt`email/${(_a = email.body) == null ? void 0 : _a.template}`, body: email }).then((response) => {
        var _a2;
        this.emit(xt`email/${(_a2 = email.body) == null ? void 0 : _a2.template}:c`, { email, response });
        return response;
      });
    }
  }
  class Groups extends ae {
    constructor(api) {
      super();
      __publicField(this, "api");
      __publicField(this, "cache", new Gt("name"));
      this.api = typeof api == "string" ? new Api(api) : api;
    }
    async all(reload) {
      if (!reload && this.cache.complete) return this.cache.all();
      return this.api.request({ url: `/api/` + xt`groups` }).then((resp) => {
        this.cache.addAll(resp);
        this.emit(xt`groups:r`, resp || []);
        return resp;
      });
    }
    delete(name) {
      if (!name) throw new Error("Cannot delete group, missing name");
      return this.api.request({
        url: `/api/` + xt`groups/${name}`,
        method: "DELETE"
      }).then(() => {
        this.cache.delete(name);
        this.emit(xt`groups/${name}:d`);
      });
    }
    create(group) {
      if (!group.name) throw new Error("Cannot create group, missing name");
      return this.api.request({
        url: `/api/` + xt`groups/${group.name}`,
        method: "POST",
        body: group
      }).then((resp) => {
        this.cache.add(resp);
        this.emit(xt`groups/${group.name}:c`, resp);
        return resp;
      });
    }
    async read(name, reload) {
      if (!name) throw new Error("Cannot read group, missing name");
      if (!reload && this.cache.get(name)) return this.cache.get(name);
      return this.api.request({ url: `/api/` + xt`groups/${name}` }).then((resp) => {
        this.cache.add(resp);
        this.emit(xt`groups/${name}:r`, resp);
        return resp;
      });
    }
    update(group) {
      if (!group.name) throw new Error("Cannot update group, missing name");
      return this.api.request({
        url: `/api/` + xt`groups/${group.name}`,
        method: "PATCH",
        body: group
      }).then((resp) => {
        this.cache.add(resp);
        this.emit(xt`groups/${group.name}:u`, resp);
        return resp;
      });
    }
  }
  class Logger extends ae {
    constructor(api, channel, logLevel) {
      super();
      __publicField(this, "api");
      __publicField(this, "console", {
        debug: console.debug,
        log: console.log,
        info: console.info,
        warn: console.warn,
        error: console.error
      });
      this.channel = channel;
      if (channel.toLowerCase() == "server") throw new Error('"Server" namespace is reserved');
      this.api = typeof api == "string" ? new Api(api) : api;
      if (logLevel != null && logLevel && logLevel != "NONE") {
        if (yt[logLevel] >= 0) {
          console.error = (...args) => {
            this.console.error(...args);
            this.error(...args);
          };
          window.addEventListener("unhandledrejection", async (event) => {
            var _a, _b, _c, _d;
            let log = ((_a = event.reason) == null ? void 0 : _a.stack) || event.reason;
            if ((_b = event.reason) == null ? void 0 : _b.url)
              log = `${event.reason.method} ${event.reason.url} -> ${event.reason.code}

${log}`;
            ((_c = event.reason) == null ? void 0 : _c.code) == null || ((_d = event.reason) == null ? void 0 : _d.code) >= 500 ? this.error(log) : this.warn(log);
          });
        }
        if (yt[logLevel] >= 1) {
          console.warn = (...args) => {
            this.console.warn(...args);
            this.warn(...args);
          };
        }
        if (yt[logLevel] >= 2) {
          console.info = (...args) => {
            this.console.info(...args);
            this.info(...args);
          };
        }
        if (yt[logLevel] >= 3) {
          console.log = (...args) => {
            this.console.log(...args);
            this.log(...args);
          };
        }
        if (yt[logLevel] >= 4) {
          console.debug = (...args) => {
            this.console.debug(...args);
            this.debug(...args);
          };
        }
      }
    }
    buildLog(level, log) {
      return {
        time: (/* @__PURE__ */ new Date()).getTime(),
        level,
        log,
        ctx: {
          cores: navigator.hardwareConcurrency,
          mem: navigator == null ? void 0 : navigator.deviceMemory,
          res: [window.innerWidth, window.innerHeight],
          url: location.href
        }
      };
    }
    create(log, channel = this.channel) {
      if (channel.toLowerCase() == "server") throw new Error('"Server" namespace is reserved');
      return this.api.request({ url: `/api/` + xt`logs/${channel}`, body: log }).then(() => this.emit(xt`logs/${channel}:c`, log)).catch(() => {
      });
    }
    delete(channel = this.channel) {
      return this.api.request({ url: `/api/` + xt`logs/${channel}`, method: "DELETE" }).then(() => this.emit(xt`logs/${channel}:d`));
    }
    read(channel = this.channel) {
      return this.api.request({ url: `/api/` + xt`logs/${channel}` }).then((logs) => {
        this.emit(xt`logs/${channel}:r`, logs);
        return logs;
      });
    }
    // Console =========================================================================================================
    debug(log, channel = this.channel) {
      return this.create(this.buildLog(yt.DEBUG, log), channel);
    }
    log(log, channel = this.channel) {
      return this.create(this.buildLog(yt.LOG, log), channel);
    }
    info(log, channel = this.channel) {
      return this.create(this.buildLog(yt.INFO, log), channel);
    }
    warn(log, channel = this.channel) {
      return this.create(this.buildLog(yt.WARN, log), channel);
    }
    error(log, channel = this.channel) {
      return this.create(this.buildLog(yt.ERROR, log), channel);
    }
  }
  class Payments extends ae {
    constructor(api, secret) {
      super();
      __publicField(this, "api");
      __publicField(this, "stripe");
      this.api = typeof api == "string" ? new Api(api) : api;
      const setup = (retry = 1) => {
        try {
          if (!Stripe) throw new Error("Stripe not added");
          this.stripe = Stripe(secret);
        } catch (err) {
          if (retry > 0) setTimeout(() => setup(retry--), 250);
          else console.warn("Stripe failed, did you add the library & setup your API key?", err);
        }
      };
      setup();
    }
    async create(amount, custom = {}) {
      if (!amount) throw new Error("Please specify a valid amount`");
      const request = await this.api.request({ url: "/api/payments", body: {
        amount,
        custom
      } });
      this.emit(xt`payments:c`, request.data.clientSecret);
      return request.data.clientSecret;
    }
    async createForm(element, amount, custom) {
      const token = await this.create(amount, custom);
      const form = this.stripe.elements({ clientSecret: token });
      form.create("payment").mount(element);
      return () => this.stripe.confirmPayment({
        elements: form,
        redirect: "if_required",
        confirmParams: { return_url: location.origin }
      });
    }
    async history(username) {
      const history = await this.api.request({ url: `/api/` + xt`payments/${username}` });
      this.emit(xt`payments/${username}:r`, history);
      return history;
    }
  }
  class Pdf extends ae {
    constructor(api) {
      super();
      __publicField(this, "api");
      this.api = typeof api == "string" ? new Api(api) : api;
    }
    createPdf(body, options) {
      return this.api.request({ url: `/api/` + xt`pdf`, body: { ...body, options }, decode: false }).then(async (resp) => {
        const blob = await resp.blob();
        if (options == null ? void 0 : options.download) {
          let filename = (options == null ? void 0 : options.filename) || Yt();
          if (!filename.endsWith(".pdf")) filename += ".pdf";
          const url = URL.createObjectURL(blob);
          pt(url, filename);
          URL.revokeObjectURL(url);
        }
        this.emit(xt`pdf:c`, blob);
        return blob;
      });
    }
    fromHtml(html, options = {}) {
      if (!html) throw new Error("Cannot create PDF, missing HTML");
      return this.createPdf({ html }, options);
    }
    fromTemplate(template, data, options = {}) {
      if (!template) throw new Error("Cannot create PDF, missing template");
      return this.createPdf({ template, data }, options);
    }
    fromUrl(url, options = {}) {
      if (!url) throw new Error("Cannot create PDF, missing URL");
      return this.createPdf({ url }, options);
    }
  }
  const _Socket = class _Socket {
    constructor(api) {
      __publicField(this, "api");
      __publicField(this, "url");
      __publicField(this, "connection");
      __publicField(this, "open", false);
      this.api = typeof api == "string" ? new Api(api) : api;
      this.url = this.api.url.replace("http", "ws");
      this.api.on("api/token", () => this.connect());
      this.connect();
    }
    close() {
      console.debug("Disconnected from Momentum");
      this.open = false;
      this.connection.close();
    }
    connect(retry = 3) {
      var _a;
      if (((_a = this.connection) == null ? void 0 : _a.readyState) < 2) this.connection.close();
      this.connection = new WebSocket(this.url + (this.api.token ? `?token=${this.api.token}` : ""));
      const timeout = setTimeout(() => {
        if (this.open) return;
        this.connection.close();
        console.error(`Momentum connection timeout`);
        if (retry > 0) this.connect(retry - 1);
      }, _Socket.timeout);
      this.connection.onclose = () => this.open = false;
      this.connection.onmessage = this.handle;
      this.connection.onopen = () => {
        this.open = true;
        clearTimeout(timeout);
        console.debug("Connected to Momentum");
      };
    }
    handle(...args) {
      console.log(args);
    }
    send(channel, payload) {
      this.connection.send(JSON.stringify({
        token: this.api.token,
        channel,
        payload
      }));
    }
  };
  __publicField(_Socket, "timeout", 1e4);
  let Socket = _Socket;
  class Storage extends ae {
    constructor(api) {
      super();
      __publicField(this, "api");
      this.api = typeof api == "string" ? new Api(api) : api;
    }
    copy(source, destination) {
      if (!source || !destination) throw new Error("Cannot copy file or folder, missing source or destination");
      return this.api.request({ url: "/api/" + xt`storage/${destination}`, body: { from: source } }).then((response) => {
        this.emit(xt`storage/${destination}:c`, response);
        return response;
      });
    }
    delete(path) {
      if (!path) throw new Error("Cannot delete file or folder, missing path");
      return this.api.request({ url: "/api/" + xt`storage/${path}`, method: "DELETE" }).then(() => {
        this.emit(xt`storage/${path}:d`, path);
      });
    }
    download(path, opts = {}) {
      if (!path) throw new Error("Cannot download file, missing path");
      return this.api.request({ ...opts, url: "/api/" + xt`storage/${path}`, decode: false }).then(async (response) => {
        const blob = await response.blob();
        const name = opts.downloadAs || path.split("/").pop();
        this.emit(xt`storage/${path}:r`, blob);
        qt(blob, name);
        return response;
      });
    }
    list(path) {
      if (!path) path = "/";
      return this.api.request({ url: "/api/" + xt`storage/${path}` + "?list" }).then((resp) => {
        this.emit(xt`storage/${path}:r`, resp);
        return resp;
      });
    }
    open(path, target = "_blank") {
      if (!path) throw new Error("Cannot download file, missing path");
      const link = `${this.api.url}/api/` + xt`storage/${path}` + (this.api.token ? `?token=${this.api.token}` : "");
      if (!target) return link;
      this.emit(xt`storage/${path}:r`, path);
      return window.open(link, target);
    }
    mkdir(path) {
      if (!path) throw new Error("Cannot make directory, missing path");
      return this.api.request({ url: "/api/" + xt`storage/${path}`, body: { directory: true } }).then((resp) => {
        this.emit(xt`storage/${path}:c`, resp);
        return resp;
      });
    }
    move(source, destination) {
      if (!source || !destination) throw new Error("Cannot move file or folder, missing source or destination");
      if (source == destination) return this.list(destination);
      return this.api.request({ url: "/api/" + xt`storage/${source}`, method: "PATCH", body: { move: destination } }).then((response) => {
        this.emit(xt`storage/${source}:u`, response);
        return response;
      });
    }
    upload(files, opts) {
      return new O(async (res, rej, prog) => {
        if (!files) files = await Ft(typeof opts == "object" ? opts : void 0);
        if (!files || Array.isArray(files) && !files.length) return [];
        const path = (opts && typeof opts == "object" ? opts == null ? void 0 : opts.path : opts) || "/";
        return Ht({
          url: `${this.api.url}/api/` + xt`storage/${path}`,
          files: b(files),
          headers: this.api.headers
        }).onProgress((p) => {
          prog(p);
        }).then((resp) => {
          this.emit(xt`storage/${path}:c`, resp);
          res(resp);
        }).catch((err) => rej(err));
      });
    }
  }
  class Users extends ae {
    constructor(api) {
      super();
      __publicField(this, "api");
      __publicField(this, "cache", new Gt("username"));
      this.api = typeof api == "string" ? new Api(api) : api;
    }
    async all(reload) {
      if (!reload && this.cache.complete) return this.cache.all();
      return this.api.request({ url: "/api/" + xt`users` }).then((resp) => {
        resp == null ? void 0 : resp.forEach((r) => {
          r.image = this.api.url + r.image + `?token=${this.api.token}`;
          return r;
        });
        this.cache.addAll(resp);
        this.emit(xt`users:r`, resp || []);
        return resp;
      });
    }
    delete(username) {
      if (!username) throw new Error("Cannot delete user, missing username");
      return this.api.request({
        url: "/api/" + xt`users/${username}`,
        method: "DELETE"
      }).then(() => {
        this.cache.delete(username);
        this.emit(xt`users/${username}:d`, username);
      });
    }
    async read(username, reload) {
      if (!username) throw new Error("Cannot read user, missing username");
      if (!reload && this.cache.get(username)) return this.cache.get(username);
      return this.api.request({ url: "/api/" + xt`users/${username}` }).then((resp) => {
        if (resp) {
          resp.image = this.api.url + resp.image + `?token=${this.api.token}`;
          this.cache.add(resp);
        }
        this.emit(xt`users/${username}:r`, resp);
        return resp;
      });
    }
    update(user) {
      if (!user.username) throw new Error("Cannot update user, missing username");
      return this.api.request({
        url: `/api/` + xt`users/${user.username}`,
        method: "PATCH",
        body: user
      }).then((resp) => {
        if (resp) {
          resp.image = this.api.url + resp.image + `?token=${this.api.token}`;
          this.cache.add(resp);
        }
        this.emit(xt`users/${user.username}:${resp._id ? "u" : "c"}`, resp);
        return resp;
      });
    }
    uploadImage(username, file) {
      if (!username || !file) throw new Error("Cannot update user image, missing username or file");
      return Ht({
        url: this.api.url + `/api/` + xt`users/${username}/image`,
        files: [file],
        headers: this.api.headers
      });
    }
  }
  class Settings extends ae {
    constructor(api) {
      super();
      __publicField(this, "api");
      __publicField(this, "cache", new Gt());
      this.api = typeof api == "string" ? new Api(api) : api;
    }
    async all(detailed = false, reload) {
      if (!reload && !detailed && this.cache.complete) return this.cache;
      return this.api.request({ url: `/api/` + xt`settings` + (detailed ? "?detailed" : "") }).then((resp) => {
        if (resp) Object.keys(resp).forEach((key) => this.cache.set(key, detailed ? resp[key].value : resp[key]));
        this.emit(xt`settings:r`, resp || []);
        return resp;
      });
    }
    delete(key) {
      if (!key) throw new Error("Cannot delete setting, missing key");
      return this.api.request({ url: `/api/` + xt`settings/${key}`, method: "DELETE" }).then(() => {
        this.cache.delete(key);
        this.emit(xt`settings/${key}:d`, key);
      });
    }
    read(key, reload = false) {
      if (!key) throw new Error("Cannot read setting, missing key");
      if (!reload && this.cache.get(key)) return this.cache.get(key);
      return this.api.request({ url: `/api/` + xt`settings/${key}` }).then((variable) => {
        if (variable) this.cache.set(variable.key, variable.value);
        this.emit(xt`settings/${key}:r`, variable);
        return variable;
      });
    }
    update(variable) {
      if (!variable.key) throw new Error("Cannot update setting, missing key");
      return this.api.request({ url: `/api/` + xt`settings/${variable.key}`, body: variable }).then((variable2) => {
        if (variable2) this.cache.set(variable2.key, variable2.value);
        this.emit(`/api/` + xt`settings/${variable2.key}:${variable2._id ? "u" : "c"}`, variable2);
        return variable2;
      });
    }
  }
  class Static extends ae {
    constructor(api) {
      super();
      __publicField(this, "api");
      this.api = typeof api == "string" ? new Api(api) : api;
    }
    delete(path) {
      if (!path) throw new Error("Cannot delete static asset, missing path");
      return this.api.request({ url: `/api/` + xt`static/${path}`, method: "DELETE" }).then(() => {
        this.emit(xt`static/${path}:d`, path);
      });
    }
    upload(files, path = "/") {
      if (!files) throw new Error("Cannot upload static assets, missing file");
      return new O(async (res, rej, prog) => {
        return Ht({
          url: this.api.url + "/api/" + xt`static/${path}`,
          files: b(files),
          headers: this.api.headers
        }).onProgress((p) => {
          prog(p);
        }).then((resp) => {
          this.emit(xt`static/${path}:c`, resp);
          res(resp);
        }).catch((err) => rej(err));
      });
    }
  }
  class Momentum extends ae {
    constructor(url, opts) {
      super();
      __publicField(this, "api");
      __publicField(this, "actions");
      __publicField(this, "ai");
      __publicField(this, "analytics");
      __publicField(this, "auth");
      __publicField(this, "client");
      __publicField(this, "data");
      __publicField(this, "email");
      __publicField(this, "groups");
      __publicField(this, "logger");
      __publicField(this, "payments");
      __publicField(this, "pdf");
      __publicField(this, "settings");
      __publicField(this, "socket");
      __publicField(this, "static");
      __publicField(this, "storage");
      __publicField(this, "users");
      this.api = new Api(url, opts == null ? void 0 : opts.api);
      this.actions = new Actions(this.api);
      this.ai = new Ai(this.api);
      this.analytics = new Analytics(this.api);
      this.auth = new Auth(this.api, {
        persist: (opts == null ? void 0 : opts.persist) ?? true,
        loginUrl: opts == null ? void 0 : opts.loginUrl
      });
      this.data = new Data(this.api);
      this.email = new Email(this.api);
      this.groups = new Groups(this.api);
      this.logger = new Logger(this.api, (opts == null ? void 0 : opts.app) || "client", opts == null ? void 0 : opts.logLevel);
      if (opts == null ? void 0 : opts.stripeSecret) this.payments = new Payments(this.api, opts.stripeSecret);
      this.pdf = new Pdf(this.api);
      this.settings = new Settings(this.api);
      if (opts == null ? void 0 : opts.socket) this.socket = new Socket(this.api);
      this.static = new Static(this.api);
      this.storage = new Storage(this.api);
      this.client = new Client(this.settings);
      this.users = new Users(this.api);
      this.relayEvents(this.actions);
      this.relayEvents(this.ai);
      this.relayEvents(this.analytics);
      this.relayEvents(this.api);
      this.relayEvents(this.auth);
      this.relayEvents(this.client);
      this.relayEvents(this.data);
      this.relayEvents(this.email);
      this.relayEvents(this.groups);
      this.relayEvents(this.logger);
      if (this.payments) this.relayEvents(this.payments);
      this.relayEvents(this.pdf);
      this.relayEvents(this.settings);
      this.relayEvents(this.static);
      this.relayEvents(this.storage);
      this.relayEvents(this.users);
      this.users.on(`*`, () => {
        if (!this.auth.user) return;
        const cached = this.users.cache.get(this.auth.user.username);
        if (cached) this.auth.user = cached;
      });
    }
  }
  exports2.ActionType = ActionType;
  exports2.Actions = Actions;
  exports2.Ai = Ai;
  exports2.Analytics = Analytics;
  exports2.Api = Api;
  exports2.Auth = Auth;
  exports2.Client = Client;
  exports2.Data = Data;
  exports2.Email = Email;
  exports2.Groups = Groups;
  exports2.Logger = Logger;
  exports2.Momentum = Momentum;
  exports2.PE = ue;
  exports2.PES = xt;
  exports2.PathEvent = y;
  exports2.PathEventEmitter = ae;
  exports2.Payments = Payments;
  exports2.Pdf = Pdf;
  exports2.Settings = Settings;
  exports2.Socket = Socket;
  exports2.Static = Static;
  exports2.Storage = Storage;
  exports2.Users = Users;
  Object.defineProperty(exports2, Symbol.toStringTag, { value: "Module" });
});
